/**
 * Copyright (c) 2009-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.extension.wsapi;

import java.util.List;

/**
 * Web service manager definition.
 * @author Christophe Hamerling - EBM WebSourcing
 */
public interface WebServiceManager {

    public static final String COMPONENT_LOGGER_NAME = "Petals.Extensions.WsApi.WebServiceManager";

    /**
     * Prefix of property names
     */
    public static final String PROPERTY_NAME_PREFIX = ExtensionController.PROPERTY_NAME_ENABLING_WSAPI + ".";

    /**
     * Prefix of property names configuring the WS API at HTTP level
     */
    public static final String PROPERTY_NAME_HTTP_PREFIX = PROPERTY_NAME_PREFIX + "http.";

    /**
     * Name of the property defining the listening port of the WS API
     */
    public static final String PROPERTY_NAME_HTTP_LISTENING_PORT = PROPERTY_NAME_HTTP_PREFIX + "port";

    /**
     * Name of the property defining the path of the WS API on the HTTP URL
     */
    public static final String PROPERTY_NAME_HTTP_PATH = PROPERTY_NAME_HTTP_PREFIX + "path";

    /**
     * Default value of the HTTP URL path of the WS API
     */
    public static final String DEFAULT_HTTP_PATH = "petals/ws";

    /**
     * Default value of the HTTP listening port of the WS API
     */
    public static final int DEFAULT_HTTP_LISTENING_PORT = 7600;

    void removeService(String name) throws WebServiceException;

    List<String> getServicesURL() throws WebServiceException;

    List<String> getServiceNames();
}
